package com.trs.ggzyexchange.controller;


import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.fasterxml.jackson.core.JsonProcessingException;
import com.trs.ggzyexchange.api.vo.Result;
import com.trs.ggzyexchange.entity.TenderDetailsVo;
import com.trs.ggzyexchange.entity.ZcBidpublicity;
import com.trs.ggzyexchange.entity.ZcPurchaseBulletin;
import com.trs.ggzyexchange.enums.ClassIfy;
import com.trs.ggzyexchange.service.GcNoticeandfileService;
import com.trs.ggzyexchange.service.TenderDetailsVoService;
import com.trs.ggzyexchange.service.ZcBidpublicityService;
import com.trs.ggzyexchange.utils.TenderDetailsVoUtils;
import org.apache.ibatis.annotations.Mapper;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.RequestMapping;

import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.RestController;

import javax.servlet.http.HttpServletRequest;
import java.util.ArrayList;
import java.util.List;

/**
 * <p>
 * 中标（成交）结果公告 前端控制器
 * </p>
 *
 * @author trs
 * @since 2023-03-03
 */
@RestController
@RequestMapping("/zc-bidpublicity")
public class ZcBidpublicityController extends BaseController {

    @Autowired
    private ZcBidpublicityService zcBidpublicityService;

    @Autowired
    private GcNoticeandfileService gcNoticeandfileService;

    @Autowired
    private TenderDetailsVoService tenderDetailsVoService;

    //@GetMapping(value = "/queryPageListAll")
    public Result<IPage<TenderDetailsVo>> queryPageListAll(
            @RequestParam(name="pageNo", defaultValue="1") Integer pageNo,
            @RequestParam(name="pageSize", defaultValue="10") Integer pageSize,
            HttpServletRequest req
    ){
        Page<ZcBidpublicity> page = new Page<ZcBidpublicity>(pageNo, pageSize);
        IPage<TenderDetailsVo> tenderDetailsVoIPage = zcBidpublicityService.queryZcBidpublicityAllList(page);
        for (TenderDetailsVo record : tenderDetailsVoIPage.getRecords()) {
            record.setNoticeTypeCode(ClassIfy.BID_ANNOUNCEMENT.getCode());
            record.setNoticeTypeName(ClassIfy.BID_ANNOUNCEMENT.getName());
            record.setTransactionTypeCode(ClassIfy.GOVERNMENT_PROCUREMENT.getCode());
            record.setTransactionTypeName(ClassIfy.GOVERNMENT_PROCUREMENT.getName());
            record = tenderDetailsVoService.getTenderDetailsVoAllOrtherZc(record);
            TenderDetailsVoUtils.isNull(record);
        }
        return Result.OK(tenderDetailsVoIPage);
    }

    //@GetMapping(value = "/queryPageListUpdateEs")
    public Integer queryPageListUpdateEs() throws JsonProcessingException {
        int count = zcBidpublicityService.count();
        Integer pageNo = 1;
        Integer pageSize = 1000;
        Integer pageNum = (int)Math.ceil((double)count/pageSize);
        List<TenderDetailsVo> tenderDetailsVos = new ArrayList<TenderDetailsVo>();
        for(int i = 1; i <= pageNum;i++){
            List<TenderDetailsVo> tenderDetailsVoListAll = getTenderDetailsVoListAll(i, pageSize);
            Boolean aBoolean = gcNoticeandfileService.parseTenderDetailsVo(tenderDetailsVoListAll);
        }
        return tenderDetailsVos.size();
    }
    public List<TenderDetailsVo> getTenderDetailsVoListAll(Integer pageNo,Integer pageSize){
        Page<ZcBidpublicity> page = new Page<ZcBidpublicity>(pageNo, pageSize);
        IPage<TenderDetailsVo> tenderDetailsVoIPage = zcBidpublicityService.queryZcBidpublicityAllList(page);
        for (TenderDetailsVo record : tenderDetailsVoIPage.getRecords()) {
            record.setNoticeTypeCode(ClassIfy.BID_ANNOUNCEMENT.getCode());
            record.setNoticeTypeName(ClassIfy.BID_ANNOUNCEMENT.getName());
            record.setTransactionTypeCode(ClassIfy.GOVERNMENT_PROCUREMENT.getCode());
            record.setTransactionTypeName(ClassIfy.GOVERNMENT_PROCUREMENT.getName());
            record = tenderDetailsVoService.getTenderDetailsVoAllOrtherZc(record);
            TenderDetailsVoUtils.isNull(record);
        }
        return tenderDetailsVoIPage.getRecords();
    }

}
